<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="企业客户" name="depotId">
						<a-select v-model:value="searchFormState.depotId" placeholder="请选择企业客户" :options="depotOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="监管类型" name="siteType">
						<a-select v-model:value="searchFormState.siteType" placeholder="请选择监管类型" :options="siteTypeOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="是否异常" name="alarmFlag">
						<a-select v-model:value="searchFormState.alarmFlag" placeholder="请选择是否异常" :options="alarmFlagOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="监管信息" name="siteMsg">
						<a-input v-model:value="searchFormState.siteMsg" placeholder="请输入监管信息"/>
					</a-form-item>
				</a-col>
				<a-col :span="5">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
					<a @click="toggleAdvanced" style="margin-left: 8px">
						{{ advanced ? '收起' : '展开' }}
						<component :is="advanced ? 'up-outlined' : 'down-outlined'"/>
					</a>
				</a-col>
				<template v-if="advanced">
					<a-col :span="4">
						<a-form-item label="异常处理" name="saveState">
							<a-select v-model:value="searchFormState.saveState" placeholder="请选择处理状态" :options="saveStateOptions"/>
						</a-form-item>
					</a-col>
				</template>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotFlyerSiteLogAdd')">
						<template #icon>
							<plus-outlined/>
						</template>
						新增
					</a-button>
					<a-button type="primary" @click="exportTable()"><export-outlined/>导出</a-button>
					<a-button danger @click="deleteBatchDepotFlyerSiteLog()" v-if="hasPerm('depotFlyerSiteLogBatchDelete')">删除</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="detailFormRef.onOpen(record)">详情</a>
						<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotFlyerSiteLog(record)">
							<a-button type="link" danger size="small" v-if="hasPerm('depotFlyerSiteLogDelete')">
								<a-divider type="vertical"/>
								删除
							</a-button>
						</a-popconfirm>

					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
	<DetailForm ref="detailFormRef"/>
</template>

<script setup name="depotFlyerSiteLog">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import DetailForm from './detailForm.vue'
import depotFlyerSiteLogApi from '@/api/biz/depotFlyerSiteLogApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import * as XLSX from "xlsx";
import moment from "moment";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const detailFormRef = ref()
const depotOptions = ref([])
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
// 查询区域显示更多控制
const advanced = ref(false)
const toggleAdvanced = () => {
	advanced.value = !advanced.value
}
const columns = [
	{
		title: '企业客户',
		dataIndex: 'depotGrainName'
	},
	{
		title: '监管类型',
		dataIndex: 'siteType'
	},
	{
		title: '监管等级',
		dataIndex: 'siteLv'
	},
	{
		title: '监管信息',
		dataIndex: 'siteMsg'
	},
	{
		title: '是否异常',
		dataIndex: 'alarmFlag'
	},
	{
		title: '异常处理',
		dataIndex: 'saveState'
	},
]
// 操作栏通过权限判断是否显示
columns.push({
	title: '操作',
	dataIndex: 'action',
	align: 'center',
	width: '150px'
})
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
	depotOptions.value = data
})
let loadDataLst
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotFlyerSiteLogApi.depotFlyerSiteLogPage(Object.assign(parameter, searchFormParam)).then((data) => {
		loadDataLst = data.records
		return data
	})
}
// 删除
const deleteDepotFlyerSiteLog = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotFlyerSiteLogApi.depotFlyerSiteLogDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotFlyerSiteLog = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotFlyerSiteLogApi.depotFlyerSiteLogDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
// 导出
const exportTable = () => {
	let tableData = [['企业客户', '监管类型', '监管等级', '监管信息', '是否异常', '处理确认状态'
		, '处理信息', '处理时间', '创建时间']]
	let idStr = ''
	if (selectedRowKeys.value.length > 0) {
		selectedRowKeys.value.map((m) => {
			idStr = idStr + ',' + m
		})
	}
	loadDataLst.map((m) => {
		if (!idStr || idStr.indexOf(m.id) > 0)
			tableData.push([m.depotGrainName, m.siteType, m.siteLv, m.siteMsg, m.alarmFlag, m.saveState
				, m.saveMsg, m.saveTime, m.createTime])
	})
	let workSheet = XLSX.utils.aoa_to_sheet(tableData)
	let bookNew = XLSX.utils.book_new()
	XLSX.utils.book_append_sheet(bookNew, workSheet, 'Sheet1')
	let name = '飞行监管日志' + moment().format('_YYYY-MM-DD') + '.xlsx'
	XLSX.writeFile(bookNew, name)
}
const siteTypeOptions = tool.dictList('飞行监管类型')
const alarmFlagOptions = tool.dictList('是否判断')
const saveStateOptions = tool.dictList('处理确认状态')
</script>
